﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Linq;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Media;
using System.Net;
using System.Globalization;

using Styx;
using Styx.Logic.Combat;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins.PluginClass;
using Styx.Logic.BehaviorTree;

using Styx.Logic.Pathing;
using Styx.Combat.CombatRoutine;
using Styx.Logic.Inventory.Frames.Quest;
using Styx.Logic.Questing;
using Styx.Plugins;
using Styx.Logic.Inventory.Frames.Gossip;
using Styx.Logic.Common;
using Styx.Logic.Inventory.Frames.Merchant;
using Styx.Logic;
using Styx.Logic.Profiles;
using Styx.Logic.Inventory.Frames.LootFrame;

namespace katzerle
{
    public partial class MoteExtractorUI : Form
    {
        public MoteExtractorUI()
        {
            InitializeComponent();
            CBArcaneVortex.Checked = MotesExtractor.Settings.ArcaneVortex;
            CBArticCloud.Checked = MotesExtractor.Settings.ArcticCloud;
            CBCinderCloud.Checked = MotesExtractor.Settings.CinderCloud;
            CBFelmist.Checked = MotesExtractor.Settings.Felmist;
            CBSteamCloud.Checked = MotesExtractor.Settings.SteamCloud;
            CBSwampGas.Checked = MotesExtractor.Settings.SwampGas;
            CBWindyCloud.Checked = MotesExtractor.Settings.WindyCloud;
            TBBlacklistTimer.Text = MotesExtractor.Settings.BlacklistTimer;
        }

        private void BReport_Click(object sender, EventArgs e)
        {
            MotesExtractor.GenerateReport();
        }

        private void BSave_Click(object sender, EventArgs e)
        {
            //----------------- Save Configfile and set Settings ---------------- 
            XmlDocument xml;
            XmlElement root;
            XmlElement element;
            XmlText text;
            XmlComment xmlComment;

            MotesExtractor.Settings.ArcaneVortex = CBArcaneVortex.Checked;
            MotesExtractor.Settings.ArcticCloud = CBArticCloud.Checked;
            MotesExtractor.Settings.CinderCloud = CBCinderCloud.Checked;
            MotesExtractor.Settings.Felmist = CBFelmist.Checked;
            MotesExtractor.Settings.SteamCloud = CBSteamCloud.Checked;
            MotesExtractor.Settings.SwampGas = CBSwampGas.Checked;
            MotesExtractor.Settings.WindyCloud = CBWindyCloud.Checked;
            MotesExtractor.Settings.BlacklistTimer = TBBlacklistTimer.Text;

            Logging.WriteDebug("Mote Extractor Save: ArcaneVortex = {0}", CBArcaneVortex.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: ArcticCloud = {0}", CBArticCloud.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: CinderCloud = {0}", CBCinderCloud.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: Felmist = {0}", CBFelmist.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: SteamCloud = {0}", CBSteamCloud.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: SwampGas = {0}", CBSwampGas.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: WindyCloud = {0}", CBWindyCloud.Checked.ToString());
            Logging.WriteDebug("Mote Extractor Save: BlacklistTimer = {0}", TBBlacklistTimer.Text.ToString());

            // ---------- Save ----------------------------			
            string sPath = Path.Combine(MotesExtractor.FolderPath, "config\\MoteExtractor.config");

            Logging.WriteDebug("Mote Extractor: Saving config file: {0}", sPath);
            Logging.Write("Mote Extractor: Settings Saved");
            xml = new XmlDocument();
            XmlDeclaration dc = xml.CreateXmlDeclaration("1.0", "utf-8", null);
            xml.AppendChild(dc);

            xmlComment = xml.CreateComment(
                "=======================================================================\n" +
                ".CONFIG  -  This is the Config File For Mote Extractor\n\n" +
                "XML file containing settings to customize in the Mote Extractor Plugin\n" +
                "It is STRONGLY recommended you use the Configuration UI to change this\n" +
                "file instead of direct changein it here.\n" +
                "========================================================================");

            //let's add the root element
            root = xml.CreateElement("MoteExtractor");
            root.AppendChild(xmlComment);

            //Rarekiller
            //let's add another element (child of the root)
            element = xml.CreateElement("ArcaneVortex");
            text = xml.CreateTextNode(CBArcaneVortex.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("WindyCloud");
            text = xml.CreateTextNode(CBWindyCloud.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("Felmist");
            text = xml.CreateTextNode(CBFelmist.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("SwampGas");
            text = xml.CreateTextNode(CBSwampGas.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("ArcticCloud");
            text = xml.CreateTextNode(CBArticCloud.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("CinderCloud");
            text = xml.CreateTextNode(CBCinderCloud.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("SteamCloud");
            text = xml.CreateTextNode(CBSteamCloud.Checked.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            //let's add another element (child of the root)
            element = xml.CreateElement("BlacklistTimer");
            text = xml.CreateTextNode(TBBlacklistTimer.Text.ToString());
            element.AppendChild(text);
            root.AppendChild(element);

            xml.AppendChild(root);

            System.IO.FileStream fs = new System.IO.FileStream(@sPath, System.IO.FileMode.Create,
                                                               System.IO.FileAccess.Write);
            try
            {
                xml.Save(fs);
                fs.Close();
            }
            catch (Exception np)
            {
                Logging.Write(System.Drawing.Color.Red, np.Message);
            }
        }


    }
}
